package cn.com.ctop.okr.controller;

import cn.com.ctop.okr.entity.OkrObjectInfoDisclosure;
import cn.com.ctop.okr.service.IOkrObjectInfoDisclosureService;
import cn.com.ctop.okr.vo.Result;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Arrays;

 /**
 * okr o 信息公开
 * @author jeecg-boot
 * @date   2020-09-04
 * @version V1.0
 */
@Slf4j
@RestController
@RequestMapping("/ctop/okrObjectInfoDisclosure")
public class OkrObjectInfoDisclosureController {
	@Autowired
	private IOkrObjectInfoDisclosureService okrObjectInfoDisclosureService;

	/**
	  * 分页列表查询
	 * @param okrObjectInfoDisclosure
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */

	@GetMapping(value = "/list")
	public Result<IPage<OkrObjectInfoDisclosure>> queryPageList(OkrObjectInfoDisclosure okrObjectInfoDisclosure,
																@RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
																@RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
																HttpServletRequest req) {
		Result<IPage<OkrObjectInfoDisclosure>> result = new Result<>();
		QueryWrapper<OkrObjectInfoDisclosure> queryWrapper = new QueryWrapper<>();
		Page<OkrObjectInfoDisclosure> page = new Page<OkrObjectInfoDisclosure>(pageNo, pageSize);
		IPage<OkrObjectInfoDisclosure> pageList = okrObjectInfoDisclosureService.page(page, queryWrapper);
		result.setSuccess(true);
		result.setResult(pageList);
		return result;
	}

	/**
	  *   添加
	 * @param okrObjectInfoDisclosure
	 * @return
	 */
	@PostMapping(value = "/add")
	public Result<OkrObjectInfoDisclosure> add(@RequestBody OkrObjectInfoDisclosure okrObjectInfoDisclosure) {
		Result<OkrObjectInfoDisclosure> result = new Result<>();
		try {
			okrObjectInfoDisclosureService.save(okrObjectInfoDisclosure);
			result.success("添加成功！");
		} catch (Exception e) {
			log.error(e.getMessage(),e);
			result.error500("操作失败");
		}
		return result;
	}

	/**
	  *  编辑
	 * @param okrObjectInfoDisclosure
	 * @return
	 */
	@PutMapping(value = "/edit")
	public Result<OkrObjectInfoDisclosure> edit(@RequestBody OkrObjectInfoDisclosure okrObjectInfoDisclosure) {
		Result<OkrObjectInfoDisclosure> result = new Result<OkrObjectInfoDisclosure>();
		OkrObjectInfoDisclosure okrObjectInfoDisclosureEntity = okrObjectInfoDisclosureService.getById(okrObjectInfoDisclosure.getId());
		if(okrObjectInfoDisclosureEntity==null) {
			result.error500("未找到对应实体");
		}else {
			boolean ok = okrObjectInfoDisclosureService.updateById(okrObjectInfoDisclosure);
			if(ok) {
				result.success("修改成功!");
			}
		}

		return result;
	}

	/**
	  *   通过id删除
	 * @param id
	 * @return
	 */
	@DeleteMapping(value = "/delete")
	public Result<?> delete(@RequestParam(name="id",required=true) String id) {
		try {
			okrObjectInfoDisclosureService.removeById(id);
		} catch (Exception e) {
			log.error("删除失败",e.getMessage());
			return Result.error("删除失败!");
		}
		return Result.ok("删除成功!");
	}

	/**
	  *  批量删除
	 * @param ids
	 * @return
	 */
	@DeleteMapping(value = "/deleteBatch")
	public Result<OkrObjectInfoDisclosure> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		Result<OkrObjectInfoDisclosure> result = new Result<>();
		if(ids==null || "".equals(ids.trim())) {
			result.error500("参数不识别！");
		}else {
			this.okrObjectInfoDisclosureService.removeByIds(Arrays.asList(ids.split(",")));
			result.success("删除成功!");
		}
		return result;
	}

	/**
	  * 通过id查询
	 * @param id
	 * @return
	 */
	@GetMapping(value = "/queryById")
	public Result<OkrObjectInfoDisclosure> queryById(@RequestParam(name="id",required=true) String id) {
		Result<OkrObjectInfoDisclosure> result = new Result<>();
		OkrObjectInfoDisclosure okrObjectInfoDisclosure = okrObjectInfoDisclosureService.getById(id);
		if(okrObjectInfoDisclosure==null) {
			result.error500("未找到对应实体");
		}else {
			result.setResult(okrObjectInfoDisclosure);
			result.setSuccess(true);
		}
		return result;
	}
}
