package cn.com.ctop.okr.controller;

import cn.com.ctop.okr.dto.UserInfoDto;
import cn.com.ctop.okr.service.QYWxService;
import cn.com.ctop.okr.vo.Result;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.List;

@Controller
@RequestMapping("/qywx")
public class QyWxController {
    private static Logger logger = Logger.getLogger(QyWxController.class);

    @Autowired
    private QYWxService wxService;

    @ResponseBody
    @RequestMapping(value = "/departAndUser")
    public Result departAndUser(HttpServletRequest request,
                          HttpServletResponse response){
        logger.info("获取企业微信公司部门和员工信息接口开始");
        Result result = new Result();
        result.setSuccess(true);

        try {
            wxService.getWxDepartAndUserInfo();
        }catch (Exception e){
            result.setSuccess(false);
            result.setMessage("获取企业微信公司部门和员工信息接口出错啦");
            logger.error(e.getMessage());
        }

        return result;
    }


    /**
     * 根据名字模糊查询企业微信用户
     * @param dto
     * @param request
     * @param response
     * @return
     */
    @ResponseBody
    @RequestMapping(value = "/getUserListByName")
    public Result<List<UserInfoDto>> getUserListByName(@RequestBody UserInfoDto dto, HttpServletRequest request,
                                                       HttpServletResponse response){
        logger.info("/qywx/getUserListByName 方法开始");
        Result<List<UserInfoDto>> result = new Result();
        result.setSuccess(true);

        try {
            List<UserInfoDto> userInfoList = wxService.getUserListByName(dto.getName());
            result.setResult(userInfoList);
        }catch (Exception e){
            logger.error(e.getMessage());
            result.setSuccess(false);
            result.setMessage("error");
        }finally {
            logger.info("/qywx/getUserListByName 方法结束");
        }

        return result;
    }

}
