package cn.com.ctop.okr.qywx.provider;

import cn.com.ctop.okr.qywx.constant.QYWxConstant;
import cn.com.ctop.okr.utils.HttpUtils;
import com.alibaba.fastjson.JSONObject;

import java.util.TreeMap;

public class AuthProvider {

    public static String getQYWXAccessToken() throws Exception{
        TreeMap<String,Object> params = new TreeMap<>();
        params.put("corpid", QYWxConstant.QYWX_CORP_ID);
        params.put("corpsecret",QYWxConstant.QYWX_CORP_SECRET);
        String resultStr = HttpUtils.httpGetRequest(QYWxConstant.QYWX_API_URL+QYWxConstant.QYWX_GET_TOKEN,null,params);
        //System.out.println(resultStr);
        JSONObject resultJson = JSONObject.parseObject(resultStr);
        Integer errcode = resultJson.getInteger("errcode");
        if(errcode == 0){
            return resultJson.getString("access_token");
        }else{
            throw new Exception("access_token获取失败，result：" + resultStr);
        }
    }

    /**
     * 获取企业微信当前登录用户信息
     * @param code
     * @param token
     */
    public static String getQYWXLoginUserinfo(String code, String token) throws Exception {
        TreeMap<String,Object> params = new TreeMap<>();
        params.put("access_token", token);
        params.put("code", code);

        String resultStr = HttpUtils.httpGetRequest(QYWxConstant.QYWX_API_URL+QYWxConstant.QYWX_GET_LOGIN_USERINFO,null,params);
        //System.out.println(resultStr);
        JSONObject resultJson = JSONObject.parseObject(resultStr);
        Integer errcode = resultJson.getInteger("errcode");
        if(errcode == 0){
            return resultJson.getString("UserId");
        }else{
            throw new Exception("获取企业微信当前登录用户信息，result：" + resultStr);
        }
    }

    public static void main(String[] args) throws Exception {
        getQYWXAccessToken();
    }


}
