package cn.com.ctop.okr.qywx.provider;

import cn.com.ctop.okr.qywx.constant.QYWxConstant;
import cn.com.ctop.okr.utils.HttpUtils;
import com.alibaba.fastjson.JSONObject;
import org.apache.commons.lang.StringUtils;

import java.util.HashMap;
import java.util.Map;
import java.util.TreeMap;

public class DepartUserProvider {

    /**
     * 获取部门信息
     * @param department_id
     * @param token
     * @return
     * @throws Exception
     */
    public static JSONObject getCorpDepartList(String department_id, String token) throws Exception {
        TreeMap<String,Object> params = new TreeMap<>();
        params.put("access_token", token);
        if(StringUtils.isNotBlank(department_id)){
            params.put("id",department_id);
        }

        String resultStr = HttpUtils.httpGetRequest(QYWxConstant.QYWX_API_URL+QYWxConstant.QYWX_DEPART_LIST,null,params);
        JSONObject resultJson = JSONObject.parseObject(resultStr);
        System.out.println(resultJson);
        return resultJson;
    }


    /**
     * 获取部门下员工简单信息
     * @param department_id
     * @param token
     * @return
     * @throws Exception
     */
    public static JSONObject getUserSimpleInfoByDepartId(Integer department_id, String token) throws Exception {
        TreeMap<String,Object> params = new TreeMap<>();
        params.put("access_token", token);
        params.put("department_id", department_id);
        params.put("fetch_child", 1);

        String resultStr = HttpUtils.httpGetRequest(QYWxConstant.QYWX_API_URL+QYWxConstant.QYWX_USER_SIMPLELIST,null,params);
        JSONObject resultJson = JSONObject.parseObject(resultStr);
        System.out.println(resultJson);
        return resultJson;
    }

    /**
     * 获取部门下员工详细信息
     * @param department_id
     * @param token
     * @return
     * @throws Exception
     */
    public static JSONObject getUserDetailInfoByDepartId(Integer department_id, String token) throws Exception {
        TreeMap<String,Object> params = new TreeMap<>();
        params.put("access_token", token);
        params.put("department_id", department_id);
        params.put("fetch_child", 1);

        String resultStr = HttpUtils.httpGetRequest(QYWxConstant.QYWX_API_URL+QYWxConstant.QYWX_USER_LIST,null,params);
        JSONObject resultJson = JSONObject.parseObject(resultStr);
        System.out.println(resultJson);
        return resultJson;
    }


    public static JSONObject convertUserIdToOpenId(String userid, String token) throws Exception{
        Map<String, Object> params = new HashMap<>();
        params.put("userid", userid);  //"qy017c8f2a6db0e90328f3ae7cc1"
        String resultStr = HttpUtils.httpPostRequest(QYWxConstant.QYWX_API_URL+QYWxConstant.QYWX_CONVERT_TO_OPENID+"?access_token="+token, params, null);
        JSONObject resultJson = JSONObject.parseObject(resultStr);
        System.out.println(resultJson);
        return resultJson;
    }

    public static void main(String[] args) throws Exception {
        //String token = AuthProvider.getQYWXAccessToken();
        String token = "jLzCVGM285_KOhhlcJzVpPa8zOPtgyRPMm0K3lPKxHQk_6fWadrdYHJBL2cHb10M5aKPFwknwUFGnbFKK7zg53468kCBxusO6PijA4zsxZZmsRFk8giQcKzzttZFJ-cq3nZ7J1vqty63bb9B40T6rQkTZ5zc8Z0esfXyrnCL7-26i_4K5lFcY5LICzM0qfPsFGUgYeEwIfPiBrLAGTw4Tw";
        System.out.println(token);
        getCorpDepartList(null,token);
        //getUserDetailInfoByDepartId(1,token);
        //convertUserIdToOpenId(null,"2qZIc_qzyZ7ZuTB4cdUAZbVDGfJCoEc6YRPyprp_KgaPMlEgi8sN5jIFCsNMy375QgnycQY8B-shloUEqFv08q9BvMppO-VC5wx89yrHFPugCD9j81-jfwxTf_PLYgLaaRY5EqDE3Yh-Ng4aOERNlOB_EgFcMSGwGja-vtKSgI5DbLrXhlVHfWbicWNdOJTeNfWcEV_WU9EsAivhadMhlQ");
    }


}
