package cn.com.ctop.okr.service.impl;

import cn.com.ctop.okr.entity.OkrKrInfo;
import cn.com.ctop.okr.entity.OkrObjectInfoDisclosure;
import cn.com.ctop.okr.entity.OkrObjectInfoRemind;
import cn.com.ctop.okr.mapper.OkrKrInfoMapper;
import cn.com.ctop.okr.service.IKrInfoservice;
import cn.com.ctop.okr.service.IOkrObjectInfoDisclosureService;
import cn.com.ctop.okr.service.IOkrObjectInfoRemindService;
import cn.com.ctop.okr.vo.PublicVO;
import cn.com.ctop.okr.vo.RemindVO;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class KrInfoserviceImpl extends ServiceImpl<OkrKrInfoMapper, OkrKrInfo> implements IKrInfoservice {
    @Override
    public void updateKrInfo(OkrKrInfo krInfo) {
        this.updateById(krInfo);
    }

    @Override
    public OkrKrInfo checkShow(OkrKrInfo krInfo, String openId) {
        String getOpenId = krInfo.getUserId();
        if(openId.equals(getOpenId)){
            //表示是本人的OKR信息  展示所有
            //查询相关@信息
            List<RemindVO> remindVOS = remindService.getRemindVOByKrId(krInfo.getId());
            krInfo.setRemindVOS(remindVOS);
            List<PublicVO> publicVOS = disclosureService.getPublicVOByKrId(krInfo.getId());
            krInfo.setPublicVOS(publicVOS);
            return krInfo;

        }else{
            Integer permission = krInfo.getPermission();
            if(permission == 2){
                //私密
                return null;
            }
            if(permission == 3){
                //对某人公开
                OkrObjectInfoDisclosure disclosureStaff = disclosureService.checkStaffByParams(krInfo.getId(),openId,2);
                OkrObjectInfoDisclosure disclosureDepart = disclosureService.checkDepartByParams(krInfo.getId(),openId,1);
                if(null == disclosureDepart&&disclosureStaff == null){
                    return null;
                }
                //查询相关@信息
                List<RemindVO> vos = remindService.getRemindVOByKrId(krInfo.getId());
                krInfo.setRemindVOS(vos);
                return krInfo;
            }
            if(permission == 1){
                //公开
                //查询相关@信息
                List<RemindVO> vos = remindService.getRemindVOByKrId(krInfo.getId());
                krInfo.setRemindVOS(vos);
                return krInfo;
            }
            return null;
        }
    }

    @Autowired
    private IOkrObjectInfoRemindService remindService;
    @Autowired
    private IOkrObjectInfoDisclosureService disclosureService;
}
