package cn.com.ctop.okr.service.impl;

import cn.com.ctop.okr.entity.OkrObjectInfoDisclosure;
import cn.com.ctop.okr.mapper.OkrObjectInfoDisclosureMapper;
import cn.com.ctop.okr.service.IOkrObjectInfoDisclosureService;
import cn.com.ctop.okr.vo.PublicVO;
import cn.com.ctop.okr.vo.RemindVO;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import io.swagger.models.auth.In;
import org.apache.ibatis.annotations.Param;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * okr o 信息公开
 * @author jeecg-boot
 * @date   2020-09-04
 * @version V1.0
 */
@Service
public class OkrObjectInfoDisclosureServiceImpl extends ServiceImpl<OkrObjectInfoDisclosureMapper, OkrObjectInfoDisclosure> implements IOkrObjectInfoDisclosureService {
    @Autowired
    private OkrObjectInfoDisclosureMapper disclosureMapper;
    @Override
    public void deleteByKrId(Long krId) {
        Map<String,Object> map=new HashMap<>();
        map.put("kr_id",krId);
        disclosureMapper.deleteByMap(map);
    }

    @Override
    public OkrObjectInfoDisclosure checkStaffByParams(Long krId, String openId, Integer publicType) {
        QueryWrapper<OkrObjectInfoDisclosure> queryWrapper = new QueryWrapper<>();
        if(null!=krId&&krId!=0){
            queryWrapper.eq("kr_id",krId);
        }
        if(null!=openId&&!"".equals(openId.trim())){
            queryWrapper.eq("public_id",krId);
        }
        queryWrapper.eq("public_type",publicType);
        queryWrapper.last("limit 1");
        return this.getOne(queryWrapper);
    }

    @Override
    public OkrObjectInfoDisclosure checkDepartByParams(Long krId, String openId, Integer publicType) {
        return disclosureMapper.checkDepartByParams(krId, openId, publicType);
    }

    @Override
    public List<PublicVO> getPublicVOByKrId(Long krId) {
        return disclosureMapper.getPublicVOByKrId(krId);
    }
}
