package cn.com.ctop.okr.service.impl;

import cn.com.ctop.okr.entity.OkrObjectInfoDisclosure;
import cn.com.ctop.okr.entity.OkrTaskInfoDisclosure;
import cn.com.ctop.okr.mapper.OkrTaskInfoDisclosureMapper;
import cn.com.ctop.okr.service.IOkrTaskInfoDisclosureService;
import cn.com.ctop.okr.vo.PublicVO;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * okr o 信息公开
 * @author jeecg-boot
 * @date   2020-09-04
 * @version V1.0
 */
@Service
public class OkrTaskInfoDisclosureServiceImpl extends ServiceImpl<OkrTaskInfoDisclosureMapper, OkrTaskInfoDisclosure> implements IOkrTaskInfoDisclosureService {
    @Autowired
    private OkrTaskInfoDisclosureMapper okrTaskInfoDisclosureMapper;
    @Override
    public void deleteByTaskId(Long taskId) {
        Map<String,Object> map=new HashMap<>();
        map.put("okr_task_id",taskId);
        okrTaskInfoDisclosureMapper.deleteByMap(map);
    }

    @Override
    public List<PublicVO> getPublicVOByTaskId(Long taskInfoId) {
        return okrTaskInfoDisclosureMapper.getPublicVOByTaskId(taskInfoId);
    }

    @Override
    public OkrTaskInfoDisclosure checkStaffByParams(Long taskInfoId, String openId, int type) {
        QueryWrapper<OkrTaskInfoDisclosure> queryWrapper = new QueryWrapper<>();
        if(null!=taskInfoId&&taskInfoId!=0){
            queryWrapper.eq("okr_task_id",taskInfoId);
        }
        if(null!=openId&&!"".equals(openId.trim())){
            queryWrapper.eq("public_id",openId);
        }
        queryWrapper.eq("public_type",type);
        queryWrapper.last("limit 1");
        return this.getOne(queryWrapper);
    }

    @Override
    public OkrTaskInfoDisclosure checkDepartByParams(Long taskInfoId, String openId, int type) {
        return okrTaskInfoDisclosureMapper.checkDepartByParams(taskInfoId,openId,type);
    }
}
