package cn.com.ctop.okr.service.impl;

import cn.com.ctop.okr.entity.OkrTaskInfo;
import cn.com.ctop.okr.entity.OkrTaskInfoDisclosure;
import cn.com.ctop.okr.mapper.OkrTaskInfoMapper;
import cn.com.ctop.okr.service.IOkrTaskInfoDisclosureService;
import cn.com.ctop.okr.service.IOkrTaskInfoRemindService;
import cn.com.ctop.okr.service.IOkrTaskInfoService;
import cn.com.ctop.okr.vo.PublicVO;
import cn.com.ctop.okr.vo.RemindVO;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class OkrTaskInfoServiceImpl extends ServiceImpl<OkrTaskInfoMapper, OkrTaskInfo> implements IOkrTaskInfoService {
    @Autowired
    private OkrTaskInfoMapper okrTaskInfoMapper;
    @Override
    public List<OkrTaskInfo> getTaskInfo(String userId, Integer year, Integer quarter, int type) {
        return okrTaskInfoMapper.getTaskInfo(userId,year,quarter,type);
    }

    @Override
    public void updateTaskInfo(OkrTaskInfo taskInfo) {
        this.updateById(taskInfo);
    }

    @Override
    public OkrTaskInfo selectById(Long id) {
        return okrTaskInfoMapper.selectById(id);
    }

    @Override
    public void deleteTaskInfoById(OkrTaskInfo okrTaskInfo) {
        okrTaskInfoMapper.deleteTaskInfoById(okrTaskInfo);
    }

    @Override
    public void insertTaskInfo(OkrTaskInfo taskInfo) {
        okrTaskInfoMapper.insertTaskInfo(taskInfo);
    }

    @Autowired
    private IOkrTaskInfoRemindService remindService;
    @Autowired
    private IOkrTaskInfoDisclosureService disclosureService;

    @Override
    public OkrTaskInfo checkShow(OkrTaskInfo taskInfo, String openId) {
        String getOpenId = taskInfo.getUserId();
        if(openId.equals(getOpenId)){
            //表示是本人的OKR信息  展示所有
            //查询相关@信息
            List<RemindVO> remindVOS = remindService.getRemindVOByTaskId(taskInfo.getId());
            taskInfo.setRemindVOS(remindVOS);
            List<PublicVO> publicVOS = disclosureService.getPublicVOByTaskId(taskInfo.getId());
            taskInfo.setPublicVOS(publicVOS);
            return taskInfo;

        }else{
            Integer permission = taskInfo.getPermission();
            if(permission == 2){
                //私密
                return null;
            }
            if(permission == 3){
                //对某人公开
                OkrTaskInfoDisclosure disclosureStaff = disclosureService.checkStaffByParams(taskInfo.getId(),openId,2);
                OkrTaskInfoDisclosure disclosureDepart = disclosureService.checkDepartByParams(taskInfo.getId(),openId,1);
                if(null == disclosureDepart&&disclosureStaff == null){
                    return null;
                }
                //查询相关@信息
                List<RemindVO> vos = remindService.getRemindVOByTaskId(taskInfo.getId());
                taskInfo.setRemindVOS(vos);
                return taskInfo;
            }
            if(permission == 1){
                //公开
                //查询相关@信息
                List<RemindVO> vos = remindService.getRemindVOByTaskId(taskInfo.getId());
                taskInfo.setRemindVOS(vos);
                return taskInfo;
            }
            return null;
        }
    }
}
